config/routes.rb
Rails.application.routes.draw do
  get 'welcome/index'
  root 'welcome#index'

  resources :turns
  resources :canchas
  get 'turns/:id/create' => 'turns#create'
  mount RailsAdmin::Engine => '/admin', as: 'rails_admin'
  devise_for :users

end

app/models/cancha.rb
class Cancha < ActiveRecord::Base
  has_many :turns

  def full_name
    "#{name} | Size #{size}"
  end
end

app/models/turn.rb
class Turn < ActiveRecord::Base
  belongs_to :cancha
end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :turns


end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/canchas_controller.rb
class CanchasController < ApplicationController
  before_action :set_cancha, only: [:show, :edit, :update, :destroy]

  # GET /canchas
  # GET /canchas.json
  def index
    @canchas = Cancha.all
  end

  # GET /canchas/1
  # GET /canchas/1.json
  def show
  end

  # GET /canchas/new
  def new
    @cancha = Cancha.new
  end

  # GET /canchas/1/edit
  def edit
  end

  # POST /canchas
  # POST /canchas.json
  def create
    @cancha = Cancha.new(cancha_params)

    respond_to do |format|
      if @cancha.save
        format.html { redirect_to @cancha, notice: 'Cancha was successfully created.' }
        format.json { render :show, status: :created, location: @cancha }
      else
        format.html { render :new }
        format.json { render json: @cancha.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /canchas/1
  # PATCH/PUT /canchas/1.json
  def update
    respond_to do |format|
      if @cancha.update(cancha_params)
        format.html { redirect_to @cancha, notice: 'Cancha was successfully updated.' }
        format.json { render :show, status: :ok, location: @cancha }
      else
        format.html { render :edit }
        format.json { render json: @cancha.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /canchas/1
  # DELETE /canchas/1.json
  def destroy
    @cancha.destroy
    respond_to do |format|
      format.html { redirect_to canchas_url, notice: 'Cancha was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_cancha
      @cancha = Cancha.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def cancha_params
      params.require(:cancha).permit(:name, :size, :price, :user_id, :cancha_id)
    end
end

app/controllers/turns_controller.rb
class TurnsController < ApplicationController
  before_action :set_turn, only: [:show, :edit, :update, :destroy]

  # GET /turns
  # GET /turns.json
  def index
      @turns = Turn.where(user_id: (current_user)).all
  end

  # GET /turns/1
  # GET /turns/1.json
  def show
  end

  # GET /turns/new
  def new
    if !(params[:cancha].nil?)
      @turns = Turn.where(cancha_id: (params[:cancha])).all
    else
      @turns = []
    end
    @turn = Turn.new
  end

  # GET /turns/1/edit
  def edit
  end

  # POST /turns
  # POST /turns.json
  def create
    if current_user.credit > 0
      current_user.credit=current_user.credit-1
      current_user.save
      date = Time.at(params[:start].to_i / 1000)
      turns_params={ :date => date,
                     :cancha_id => params[:cancha],
                     :user_id => current_user.id}
      @turn = Turn.new(turns_params)
        respond_to do |format|
          if @turn.save
            format.html { redirect_to turns_path, notice: 'Turn was successfully created.' }
            format.json { render :show, status: :created, location: @turn }
          else
            format.html { render :new }
            format.json { render json: @turn.errors, status: :unprocessable_entity }
          end
        end
    else
      flash[:notice] = "No tiene creditos para reservar el turno"
      redirect_to action: "new"
    end
  end

  # PATCH/PUT /turns/1
  # PATCH/PUT /turns/1.json
  def update
    respond_to do |format|
      if @turn.update(turn_params)
        format.html { redirect_to @turn, notice: 'Turn was successfully updated.' }
        format.json { render :show, status: :ok, location: @turn }
      else
        format.html { render :edit }
        format.json { render json: @turn.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /turns/1
  # DELETE /turns/1.json
  def destroy
    @turn.destroy
    respond_to do |format|
      format.html { redirect_to turns_url, notice: 'Turn was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_turn
      @turn = Turn.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def turn_params
      params.require(:turn).permit(:date, :user_id, :cancha_id)
    end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
  def index
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/canchas_helper.rb
module CanchasHelper
end

app/helpers/turns_helper.rb
module TurnsHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/canchas/_form.html.erb
<%= form_for(@cancha) do |f| %>
  <% if @cancha.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@cancha.errors.count, "error") %> prohibited this cancha from being saved:</h2>

      <ul>
      <% @cancha.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br>
    <%= f.text_field :name %>
  </div>
  <div class="field">
    <%= f.label :size %><br>
    <%= f.number_field :size %>
  </div>
  <div class="field">
    <%= f.label :price %><br>
    <%= f.text_field :price %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/canchas/edit.html.erb
<h1>Editing Cancha</h1>

<%= render 'form' %>

<%= link_to 'Show', @cancha %> |
<%= link_to 'Back', canchas_path %>

app/views/canchas/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Canchas</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Size</th>
      <th>Price</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @canchas.each do |cancha| %>
      <tr>
        <td><%= cancha.name %></td>
        <td><%= cancha.size %></td>
        <td><%= cancha.price %></td>
        <td><%= link_to 'Show', cancha %></td>
        <td><%= link_to 'Edit', edit_cancha_path(cancha) %></td>
        <td><%= link_to 'Destroy', cancha, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Cancha', new_cancha_path %>

app/views/canchas/new.html.erb
<h1>New Cancha</h1>

<%= render 'form' %>

<%= link_to 'Back', canchas_path %>

app/views/canchas/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @cancha.name %>
</p>

<p>
  <strong>Size:</strong>
  <%= @cancha.size %>
</p>

<p>
  <strong>Price:</strong>
  <%= @cancha.price %>
</p>


<%= link_to 'Edit', edit_cancha_path(@cancha) %> |
<%= link_to 'Back', canchas_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Project</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>
    <nav class="navbar navbar-default" style="margin-bottom: 0px; float: right">
      <div class="container-fluid">
        <p class="nav navbar-text navbar-right">
          <% if user_signed_in? %>
              Logged in as <strong><%= current_user.email %></strong>.

              <%= link_to "Logout", destroy_user_session_path, :method=> :delete, :class => 'navbar-link'  %>
          <% else %>
              <%= link_to "Sign up", new_user_registration_path, :class => 'navbar-link'  %> |
              <%= link_to "Login", new_user_session_path, :class => 'navbar-link'  %>
          <% end %>

        </p>
      </div>
    </nav>

    <div id="wrapper">

      <!-- Sidebar -->
      <div id="sidebar-wrapper">
        <ul class="sidebar-nav">
          <li class="sidebar-brand">
            <a href="#">
              <h1>Reservas</h1>
            </a>
          </li>
          <h4>
              <li>

                <%= link_to "Reservar tu turno", new_turn_path %>

              </li>
              <li>
                <%= link_to "Ver tus turno", turns_path %>
              </li>
            <li>
              <%= link_to "Comprar creditos", turns_path %>
            </li>
              <li>
                <%= link_to 'Editar perfil', edit_user_registration_path, :class => 'navbar-link' %> |
              </li>
          </h4>
        </ul>
      </div>
    </div>
      <div class="container-fluid">
        <div class="row">
          <div class="col-lg-8 col-sm-offset-3">
            <%= yield %>
          </div>
        </div>
    </div>


</body>
</html>

app/views/turns/_form.html.erb
<%= form_for(@turn) do |f| %>
  <% if @turn.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@turn.errors.count, "error") %> prohibited this turn from being saved:</h2>

      <ul>
      <% @turn.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :cancha_id %><br>
    <%= f.collection_select(:cancha_id, Cancha.all, :id, :name) %><br><br>
  </div>

<% end %>

app/views/turns/edit.html.erb
<h1>Editing Turn</h1>

<%= render 'form' %>

<%= link_to 'Show', @turn %> |
<%= link_to 'Back', turns_path %>

app/views/turns/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Turns</h1>
<div class="row">
  <div class="col-md-10">
    <table class="table table-striped">
      <thead>
        <tr>
          <th>Date</th>
          <th colspan="1"></th>
        </tr>
      </thead>

      <tbody>
        <% @turns.each do |turn| %>
          <tr>
            <td><%= turn.date %></td>
             <td><%= link_to 'Destroy', turn, method: :delete, data: { confirm: 'Are you sure?' } %></td>
          </tr>
        <% end %>
      </tbody>

    </table>
  </div>
</div>

app/views/turns/new.html.erb
<p id="notice"><%= notice %></p>

<h1>New Turn</h1>
<div class="row">
  <div class="col-md-4">
    <form method="get">
      <div class="form-group">
        <%= select_tag 'cancha', options_from_collection_for_select(Cancha.all, 'id', :full_name), {class: "form-control"}  %>
      </div>
      <input class="btn btn-default" type="submit"/>
    </form>
    </div>
</div>

<div class="row">

  <div id="calendar"></div>
</div>


<script>
    $('#calendar').fullCalendar({
        lang: 'es',
        businessHours: {
            start: '08:00',
            end: '24:00'
        },
        minTime: "08:00:00",
        maxTime: "24:00:00",
        slotDuration:'01:00:00',
        slotEventOverlap: false,
        defaultView: 'agendaWeek',
        allDaySlot: false,
        height: 386,
        defaultTimedEventDuration: '01:00:00',
        header: {
            left:   'title',
            center: '',
            right:  'today prev,next'
        },
        selectable: true,
        selectHelper: true,
        select: function(start, allDay) {
            var title = confirm('Desea reservar el turno?');
            if (title == true) {
                $('#calendar').fullCalendar('renderEvent',
                        {
                            start: start
                        },
                        true
                );
                window.location = '/turns/<%= current_user.id %>/create?start='+ start + '&cancha=' + <%= params[:cancha] %>;
            };

            $('#calendar').fullCalendar('unselect');
        },
        editable: false,
        events: [
            <% @turns.each do |turn| %>
            {
                title  : '<%= turn.cancha.name %>',
                start  : '<%= turn.date.to_formatted_s(:iso8601) %>'
            },
        <% end %>
        ]

    })
</script>

app/views/turns/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Date:</strong>
  <%= @turn.date %>
</p>

<%= link_to 'Edit', edit_turn_path(@turn) %> |
<%= link_to 'Back', turns_path %>